#include <R.h>
#include <R_ext/Utils.h>

#define X(_m,_i,_j,_nrow) _m[ _i + _nrow * _j ]

double ed(double *x, int row1, int row2, int ncol,int nrow)
{
    int i;
    register double d = 0;
    for (i = 0; i < ncol; i++) 
        d += ( X(x,row1,i,nrow) - X(x,row2,i,nrow)) * ( X(x,row1,i,nrow) - X(x,row2,i,nrow));
    return(sqrt(d));
}

void pairdist(double *dat, int *nr, int *nc, double *dist) 
{
    int i,j,k;
    double d;

    /* asume that dist comes in allocated with the correct
     * dimenions
     */
    for (i = 0; i < *nr-1; i++)
      {
        for (j = i+1; j < *nr; j++)
          {
            d = ed(dat, i,j, *nc, *nr);
            X(dist,i,j,*nr) = d;
            X(dist,j,i,*nr) = d;
          }
      }
    return;
}



